######################## BEGIN LICENSE BLOCK ########################
# The Original Code is mozilla.org code.
#
# The Initial Developer of the Original Code is
# Netscape Communications Corporation.
# Portions created by the Initial Developer are Copyright (C) 1998
# the Initial Developer. All Rights Reserved.
#
# Contributor(s):
#   Mark Pilgrim - port to Python
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
# 02110-1301  USA
######################### END LICENSE BLOCK #########################

from .mbcharsetprober import MultiByteCharSetProber
from .codingstatemachine import CodingStateMachine
from .chardistribution import SJISDistributionAnalysis
from .jpcntx import SJISContextAnalysis
from .mbcssm import SJIS_SM_MODEL
from .enums import ProbingState, MachineState


class SJISProber(MultiByteCharSetProber):
    # 初始化函数
    def __init__(self):
        # 调用父类的初始化函数
        super(SJISProber, self).__init__()
        # 初始化编码状态机
        self.coding_sm = CodingStateMachine(SJIS_SM_MODEL)
        # 初始化分布分析器
        self.distribution_analyzer = SJISDistributionAnalysis()
        # 初始化上下文分析器
        self.context_analyzer = SJISContextAnalysis()
        # 重置分析器
        self.reset()

    # 重置函数
    def reset(self):
        # 调用父类的重置函数
        super(SJISProber, self).reset()
        # 重置上下文分析器
        self.context_analyzer.reset()

    @property
    def charset_name(self):
        # 返回字符集名称
        return self.context_analyzer.charset_name

    @property
    def language(self):
        # 返回语言
        return "Japanese"

    def feed(self, byte_str):
        # 遍历字节字符串
        for i in range(len(byte_str)):
            # 获取下一个状态
            coding_state = self.coding_sm.next_state(byte_str[i])
            # 如果状态为错误
            if coding_state == MachineState.ERROR:
                # 记录错误日志
                self.logger.debug('%s %s prober hit error at byte %s',
                                  self.charset_name, self.language, i)
                # 设置状态为不是该字符集
                self._state = ProbingState.NOT_ME
                break
            # 如果状态为确定
            elif coding_state == MachineState.ITS_ME:
                # 设置状态为确定
                self._state = ProbingState.FOUND_IT
                break
            # 如果状态为开始
            elif coding_state == MachineState.START:
                # 获取当前字符长度
                char_len = self.coding_sm.get_current_charlen()
                # 如果是第一个字符
                if i == 0:
                    # 更新最后一个字符
                    self._last_char[1] = byte_str[0]
                    # 向上下文分析器输入字符
                    self.context_analyzer.feed(self._last_char[2 - char_len:],
                                               char_len)
                    # 向分布分析器输入字符
                    self.distribution_analyzer.feed(self._last_char, char_len)
                else:
                    # 向上下文分析器输入字符
                    self.context_analyzer.feed(byte_str[i + 1 - char_len:i + 3
                                                        - char_len], char_len)
                    # 向分布分析器输入字符
                    self.distribution_analyzer.feed(byte_str[i - 1:i + 1],
                                                    char_len)

        # 更新最后一个字符
        self._last_char[0] = byte_str[-1]

        # 如果状态为检测中
        if self.state == ProbingState.DETECTING:
            # 如果上下文分析器有足够的数据，并且置信度大于阈值
            if (self.context_analyzer.got_enough_data() and
               (self.get_confidence() > self.SHORTCUT_THRESHOLD)):
                # 设置状态为确定
                self._state = ProbingState.FOUND_IT

        # 返回状态
        return self.state

    # 获取置信度
    def get_confidence(self):
        # 获取上下文分析器的置信度
        context_conf = self.context_analyzer.get_confidence()
        # 获取分布分析器的置信度
        distrib_conf = self.distribution_analyzer.get_confidence()
        # 返回上下文置信度和分布置信度中的最大值
        return max(context_conf, distrib_conf)
